Index: librt/primitives/bspline/nurb_interp.c
===================================================================
--- librt/primitives/bspline/nurb_interp.c	(revision 54048)
+++ librt/primitives/bspline/nurb_interp.c	(working copy)
@@ -128,9 +128,9 @@
 
     /* Free up node and interp_mat storage */
 
-    bu_free((char *) interp_mat, "rt_nurb_cinterp: interp_mat");
-    bu_free((char *) nodes, "rt_nurb_cinterp: nodes");
-    bu_free((char *) local_data, "rt_nurb_cinterp() local_data[]");
+    bu_free((genptr_t) interp_mat, "rt_nurb_cinterp: interp_mat");
+    bu_free((genptr_t) nodes, "rt_nurb_cinterp: nodes");
+    bu_free((genptr_t) local_data, "rt_nurb_cinterp() local_data[]");
 
     /* All done, The resulting crv now interpolates the data */
 }
@@ -224,8 +224,8 @@
     for (y = 0; y < ymax; y++) {
 	rt_nurb_clean_cnurb(&crv[y]);
     }
-    bu_free((char *)crv, "crv[]");
-    bu_free((char *)tmp, "tmp[]");
+    bu_free((genptr_t)crv, "crv[]");
+    bu_free((genptr_t)tmp, "tmp[]");
 }
 
 
Index: librt/primitives/bspline/bspline.cpp
===================================================================
--- librt/primitives/bspline/bspline.cpp	(revision 54048)
+++ librt/primitives/bspline/bspline.cpp	(working copy)
@@ -181,7 +181,7 @@
 	    rt_nurb_free_snurb(s, (struct resource *)NULL);
 	}
 	rt_nurb_free_snurb(nurbs->srf, (struct resource *)NULL);	/* original surf */
-	bu_free((char *)nurbs, "nurb_specific");
+	bu_free((genptr_t)nurbs, "nurb_specific");
     }
 
     return 0;
@@ -406,7 +406,7 @@
 
 		o = hp;
 		hp = hp->next;
-		bu_free((char *)o,
+		bu_free((genptr_t)o,
 			"rt_nurb_shot:rt_nurb_uv_hit structure");
 
 		rt_nurb_add_hit(&hit_list, hit, tol);
@@ -449,7 +449,7 @@
 	    segp->seg_out.hit_vpriv[0] = h2->hit_uv[0];
 	    segp->seg_out.hit_vpriv[1] = h2->hit_uv[1];
 	    segp->seg_out.hit_private = h2->hit_private;
-	    bu_free((char *)h2, "rt_nurb_shot: nurb hit");
+	    bu_free((genptr_t)h2, "rt_nurb_shot: nurb hit");
 	    hit_num++;
 	} else {
 	    segp->seg_out.hit_dist = h1->hit_dist + .01;
@@ -461,7 +461,7 @@
 	    segp->seg_out.hit_private = h1->hit_private;
 	}
 
-	bu_free((char *)h1, "rt_nurb_shot:nurb hit");
+	bu_free((genptr_t)h1, "rt_nurb_shot:nurb hit");
 
 	BU_LIST_INSERT(&(seghead->l), &(segp->l));
     }
@@ -590,7 +590,7 @@
 	    rt_nurb_free_snurb(s, (struct resource *)NULL);
 	}
 	rt_nurb_free_snurb(nurb->srf, (struct resource *)NULL);	/* original surf */
-	bu_free((char *)nurb, "nurb_specific");
+	bu_free((genptr_t)nurb, "nurb_specific");
     }
     return;
 #endif /* CONVERT_TO_BREP */
@@ -715,8 +715,8 @@
 	if (refined_row) {
 	    rt_nurb_free_snurb(c, (struct resource *)NULL);
 	}
-	bu_free((char *) tkv1.knots, "rt_nurb_plot:tkv1>knots");
-	bu_free((char *) tkv2.knots, "rt_nurb_plot:tkv2.knots");
+	bu_free((genptr_t) tkv1.knots, "rt_nurb_plot:tkv1>knots");
+	bu_free((genptr_t) tkv2.knots, "rt_nurb_plot:tkv2.knots");
     }
 #endif
 
@@ -1416,7 +1416,7 @@
 	    if (nurb->srfs) {
 		for (i=0; i<nurb->nsrf; i++)
 		    rt_nurb_free_snurb(nurb->srfs[i], NULL);
-		bu_free((char *)nurb->srfs, "nurb surfaces");
+		bu_free((genptr_t)nurb->srfs, "nurb surfaces");
 	    }
 	    nurb->nsrf = atoi(argv[1]);
 	    nurb->srfs = (struct face_g_snurb **) bu_calloc(
@@ -1475,14 +1475,14 @@
 			    s_size[0], s_size[1],
 			    pt_type, (struct resource *)NULL);
 			srf = nurb->srfs[srf_no];
-			bu_free((char *)order, "order");
-			bu_free((char *)s_size, "s_size");
+			bu_free((genptr_t)order, "order");
+			bu_free((genptr_t)s_size, "s_size");
 			(void)memcpy(srf->u.knots, u_pts,
 				     srf->u.k_size * sizeof(fastf_t));
 			(void)memcpy(srf->v.knots, v_pts,
 				     srf->v.k_size * sizeof(fastf_t));
-			bu_free((char *)u_pts, "u_pts");
-			bu_free((char *)v_pts, "v_pts");
+			bu_free((genptr_t)u_pts, "u_pts");
+			bu_free((genptr_t)v_pts, "v_pts");
 			tmp_len = srf->s_size[0] * srf->s_size[1] *
 			    RT_NURB_EXTRACT_COORDS(srf->pt_type);
 			tmp2 = tmp_len;
Index: librt/primitives/hf/hf.c
===================================================================
--- librt/primitives/hf/hf.c	(revision 54048)
+++ librt/primitives/hf/hf.c	(working copy)
@@ -1657,7 +1657,7 @@
 	bu_close_mapped_file(hf->hf_mp);
 	hf->hf_mp = (struct bu_mapped_file *)0;
     }
-    bu_free((char *)hf, "hf_specific");
+    bu_free((genptr_t)hf, "hf_specific");
 }
 
 
@@ -1999,7 +1999,7 @@
     if (bu_struct_parse(&str, rt_hf_parse, (char *)xip) < 0) {
 	bu_vls_free(&str);
     err1:
-	bu_free((char *)xip, "rt_hf_import4: xip");
+	bu_free((genptr_t)xip, "rt_hf_import4: xip");
 	ip->idb_type = ID_NULL;
 	ip->idb_ptr = (genptr_t)NULL;
 	return -2;
@@ -2242,7 +2242,7 @@
 	bu_close_mapped_file(xip->mp);
     }
 
-    bu_free((char *)xip, "hf ifree");
+    bu_free((genptr_t)xip, "hf ifree");
     ip->idb_ptr = GENPTR_NULL;	/* sanity */
 }
 /**
Index: librt/primitives/rec/rec.c
===================================================================
--- librt/primitives/rec/rec.c	(revision 54048)
+++ librt/primitives/rec/rec.c	(working copy)
@@ -897,7 +897,7 @@
     struct rec_specific *rec =
 	(struct rec_specific *)stp->st_specific;
 
-    bu_free((char *)rec, "rec_specific");
+    bu_free((genptr_t)rec, "rec_specific");
 }
 
 
Index: librt/primitives/half/half.c
===================================================================
--- librt/primitives/half/half.c	(revision 54048)
+++ librt/primitives/half/half.c	(working copy)
@@ -395,7 +395,7 @@
     register struct half_specific *halfp =
 	(struct half_specific *)stp->st_specific;
 
-    bu_free((char *)halfp, "half_specific");
+    bu_free((genptr_t)halfp, "half_specific");
 }
 
 
Index: librt/primitives/tgc/tgc.c
===================================================================
--- librt/primitives/tgc/tgc.c	(revision 54048)
+++ librt/primitives/tgc/tgc.c	(working copy)
@@ -1342,7 +1342,7 @@
 	    }
 	}
     } /* end for each ray/cone pair */
-    bu_free((char *)C, "tor bn_poly_t");
+    bu_free((genptr_t)C, "tor bn_poly_t");
 }
 
 
@@ -1531,7 +1531,7 @@
     register struct tgc_specific *tgc =
 	(struct tgc_specific *)stp->st_specific;
 
-    bu_free((char *)tgc, "tgc_specific");
+    bu_free((genptr_t)tgc, "tgc_specific");
 }
 
 
@@ -2676,12 +2676,12 @@
     }
 
     /* Finished with storage, so free it */
-    bu_free((char *)factors, "rt_tgc_tess: factors");
-    bu_free((char *)A, "rt_tgc_tess: A");
-    bu_free((char *)B, "rt_tgc_tess: B");
+    bu_free((genptr_t)factors, "rt_tgc_tess: factors");
+    bu_free((genptr_t)A, "rt_tgc_tess: A");
+    bu_free((genptr_t)B, "rt_tgc_tess: B");
     for (i=0; i<nells; i++)
-	bu_free((char *)pts[i], "rt_tgc_tess: pts[i]");
-    bu_free((char *)pts, "rt_tgc_tess: pts");
+	bu_free((genptr_t)pts[i], "rt_tgc_tess: pts[i]");
+    bu_free((genptr_t)pts, "rt_tgc_tess: pts");
 
     /* mark real edges for top and bottom faces */
     for (i=0; i<2; i++) {
Index: librt/primitives/sketch/sketch.c
===================================================================
--- librt/primitives/sketch/sketch.c	(revision 54048)
+++ librt/primitives/sketch/sketch.c	(working copy)
@@ -769,7 +769,7 @@
 			    else
 				RT_ADD_VLIST(vhead, pt, BN_VLIST_LINE_DRAW);
 		}
-		bu_free((char *)eg.ctl_points, "eg.ctl_points");
+		bu_free((genptr_t)eg.ctl_points, "eg.ctl_points");
 		break;
 	    }
 	case CURVE_BEZIER_MAGIC: {
@@ -864,10 +864,10 @@
 			   bz->ctl[i][1], v_vec);
 		    RT_ADD_VLIST(vhead, pt, BN_VLIST_LINE_DRAW);
 		}
-		bu_free((char *)bz->ctl, "g_sketch.c: bz->ctl");
-		bu_free((char *)bz, "g_sketch.c: bz");
+		bu_free((genptr_t)bz->ctl, "g_sketch.c: bz->ctl");
+		bu_free((genptr_t)bz, "g_sketch.c: bz");
 	    }
-	    bu_free((char *)bezier_hd, "g_sketch.c: bezier_hd");
+	    bu_free((genptr_t)bezier_hd, "g_sketch.c: bezier_hd");
 	    break;
 	}
 	default:
@@ -1957,7 +1957,7 @@
     size_t i;
 
     if (crv->count)
-	bu_free((char *)crv->reverse, "crv->reverse");
+	bu_free((genptr_t)crv->reverse, "crv->reverse");
     for (i=0; i<crv->count; i++) {
 	uint32_t *lng;
 	struct nurb_seg *nsg;
@@ -1967,20 +1967,20 @@
 	switch (*lng) {
 	    case CURVE_NURB_MAGIC:
 		nsg = (struct nurb_seg *)lng;
-		bu_free((char *)nsg->ctl_points, "nsg->ctl_points");
+		bu_free((genptr_t)nsg->ctl_points, "nsg->ctl_points");
 		if (nsg->weights)
-		    bu_free((char *)nsg->weights, "nsg->weights");
-		bu_free((char *)nsg->k.knots, "nsg->k.knots");
-		bu_free((char *)lng, "curve segment");
+		    bu_free((genptr_t)nsg->weights, "nsg->weights");
+		bu_free((genptr_t)nsg->k.knots, "nsg->k.knots");
+		bu_free((genptr_t)lng, "curve segment");
 		break;
 	    case CURVE_BEZIER_MAGIC:
 		bsg = (struct bezier_seg *)lng;
-		bu_free((char *)bsg->ctl_points, "bsg->ctl_points");
-		bu_free((char *)lng, "curve segment");
+		bu_free((genptr_t)bsg->ctl_points, "bsg->ctl_points");
+		bu_free((genptr_t)lng, "curve segment");
 		break;
 	    case CURVE_LSEG_MAGIC:
 	    case CURVE_CARC_MAGIC:
-		bu_free((char *)lng, "curve segment");
+		bu_free((genptr_t)lng, "curve segment");
 		break;
 	    default:
 		bu_log("ERROR: rt_curve_free: unrecognized curve segments type!\n");
@@ -1989,7 +1989,7 @@
     }
 
     if (crv->count > 0)
-	bu_free((char *)crv->segment, "crv->segments");
+	bu_free((genptr_t)crv->segment, "crv->segments");
 
     crv->count = 0;
     crv->reverse = (int *)NULL;
@@ -2021,13 +2021,13 @@
     }
 
     if (sketch_ip->verts)
-	bu_free((char *)sketch_ip->verts, "sketch_ip->verts");
+	bu_free((genptr_t)sketch_ip->verts, "sketch_ip->verts");
 
     crv = &sketch_ip->curve;
 
     rt_curve_free(crv);
 
-    bu_free((char *)sketch_ip, "sketch ifree");
+    bu_free((genptr_t)sketch_ip, "sketch ifree");
     ip->idb_ptr = GENPTR_NULL;	/* sanity */
 
     if (bu_debug&BU_DEBUG_MEM_CHECK) {
@@ -2516,7 +2516,7 @@
 	    }
 
 	    if (skt->verts)
-		bu_free((char *)skt->verts, "verts");
+		bu_free((genptr_t)skt->verts, "verts");
 	    skt->verts = (point2d_t *)new_verts;
 	    skt->vert_count = len / 2;
 	} else if (BU_STR_EQUAL(argv[0], "SL")) {
Index: librt/primitives/nmg/nmg_ck.c
===================================================================
--- librt/primitives/nmg/nmg_ck.c	(revision 54048)
+++ librt/primitives/nmg/nmg_ck.c	(working copy)
@@ -1717,7 +1717,7 @@
 
     bu_ptbl_free(&tab);
 
-    bu_free((char *)st.visited, "visited[]");
+    bu_free((genptr_t)st.visited, "visited[]");
 }
 
 
Index: librt/primitives/nmg/nmg_tri.c
===================================================================
--- librt/primitives/nmg/nmg_tri.c	(revision 54048)
+++ librt/primitives/nmg/nmg_tri.c	(working copy)
@@ -275,7 +275,7 @@
     }
 
 
-    bu_free((char *)b, "plot table");
+    bu_free((genptr_t)b, "plot table");
     fclose(fp);
 }
 
@@ -4677,10 +4677,10 @@
 out1:
     while (BU_LIST_WHILE(pt, pt2d, tbl2d)) {
 	BU_LIST_DEQUEUE(&pt->l);
-	bu_free((char *)pt, "pt2d free");
+	bu_free((genptr_t)pt, "pt2d free");
     }
 
-    bu_free((char *)tbl2d, "discard tbl2d");
+    bu_free((genptr_t)tbl2d, "discard tbl2d");
 
 out2:
     return ret;
@@ -4870,14 +4870,14 @@
 
     while (BU_LIST_WHILE(tp, trap, &tlist)) {
 	BU_LIST_DEQUEUE(&tp->l);
-	bu_free((char *)tp, "trapezoid free");
+	bu_free((genptr_t)tp, "trapezoid free");
     }
 
     while (BU_LIST_WHILE(pt, pt2d, tbl2d)) {
 	BU_LIST_DEQUEUE(&pt->l);
-	bu_free((char *)pt, "pt2d free");
+	bu_free((genptr_t)pt, "pt2d free");
     }
-    bu_free((char *)tbl2d, "discard tbl2d");
+    bu_free((genptr_t)tbl2d, "discard tbl2d");
 
     return;
 }
Index: librt/primitives/nmg/nmg_fcut.c
===================================================================
--- librt/primitives/nmg/nmg_fcut.c	(revision 54048)
+++ librt/primitives/nmg/nmg_fcut.c	(working copy)
@@ -1571,7 +1571,7 @@
 	rt_plot_vlblock(fp, vbp);
 	fclose(fp);
 	bu_log("wrote %s\n", buf);
-	bu_free((char *)b, "nmg_special_wedge_processing flag[]");
+	bu_free((genptr_t)b, "nmg_special_wedge_processing flag[]");
 	rt_vlblock_free(vbp);
     }
 
@@ -1875,8 +1875,8 @@
 	}
     }
 
-    bu_free((char *)vs, "nmg_vu_stuff");
-    bu_free((char *)ls, "nmg_loop_stuff");
+    bu_free((genptr_t)vs, "nmg_vu_stuff");
+    bu_free((genptr_t)ls, "nmg_loop_stuff");
 
     if (rt_g.NMG_debug&DEBUG_VU_SORT)
 	bu_log("nmg_face_coincident_vu_sort(, %d, %d) END, ret=%d\n", start, end, start+nvu);
@@ -2890,7 +2890,7 @@
 		rs->vu[prior_end-1-cut_no] = eu_tmp->vu_p;
 	    }
 	    bu_ptbl_free(cuts);
-	    bu_free((char *)cuts, "cuts");
+	    bu_free((genptr_t)cuts, "cuts");
 
 	    continue;
 	}
Index: librt/primitives/nmg/nmg_fuse.c
===================================================================
--- librt/primitives/nmg/nmg_fuse.c	(revision 54048)
+++ librt/primitives/nmg/nmg_fuse.c	(working copy)
@@ -1190,7 +1190,7 @@
 	}
     }
 
-    bu_free((char *)edgeuse_vert_list, "edgeuse_vert_list");
+    bu_free((genptr_t)edgeuse_vert_list, "edgeuse_vert_list");
 
     /* if bu_ptbl was passed into this function don't free it here */
     if (*magic_p != BU_PTBL_MAGIC) {
@@ -3388,7 +3388,7 @@
     bu_ptbl_free(&shell_tbl);
     while (BU_LIST_WHILE(rad, nmg_radial, &list1)) {
 	BU_LIST_DEQUEUE(&rad->l);
-	bu_free((char *)rad, "nmg_radial");
+	bu_free((genptr_t)rad, "nmg_radial");
     }
     return;
 }
@@ -3494,7 +3494,7 @@
 	/* Release the storage */
 	while (BU_LIST_WHILE(rad, nmg_radial, &list)) {
 	    BU_LIST_DEQUEUE(&rad->l);
-	    bu_free((char *)rad, "nmg_radial");
+	    bu_free((genptr_t)rad, "nmg_radial");
 	}
     }
 
Index: librt/primitives/nmg/nmg_class.c
===================================================================
--- librt/primitives/nmg/nmg_class.c	(revision 54048)
+++ librt/primitives/nmg/nmg_class.c	(working copy)
@@ -391,7 +391,7 @@
 	VJOIN1(left_pt, mid_pt, 500, left);
 	pdv_3line(fp, mid_pt, left_pt);
 	fclose(fp);
-	bu_free((char *)bits, "bits[]");
+	bu_free((genptr_t)bits, "bits[]");
 	bu_log("wrote %s\n", buf);
     }
 }
@@ -771,7 +771,7 @@
 
 out:
     if (!in_or_out_only) {
-	bu_free((char *)faces_seen, "nmg_class_pt_s faces_seen[]");
+	bu_free((genptr_t)faces_seen, "nmg_class_pt_s faces_seen[]");
     }
 
     if (rt_g.NMG_debug & DEBUG_CLASSIFY) {
@@ -1657,7 +1657,7 @@
 		}
 		nmg_pr_lu(lu, "");
 		nmg_stash_model_to_file("class.g", nmg_find_model((uint32_t *)lu), "class_ls_vs_s: loop transits plane of shell/face?");
-		bu_free((char *)b, "nmg_pl_lu flag[]");
+		bu_free((genptr_t)b, "nmg_pl_lu flag[]");
 	    }
 
 	    if (seen_error > 3) {
Index: librt/primitives/nmg/nmg_rt_segs.c
===================================================================
--- librt/primitives/nmg/nmg_rt_segs.c	(revision 54048)
+++ librt/primitives/nmg/nmg_rt_segs.c	(working copy)
@@ -1136,8 +1136,8 @@
 
     bu_ptbl_free(next_tbl);
     bu_ptbl_free(a_tbl);
-    (void)bu_free((char *)a_tbl, "a_tbl");
-    (void)bu_free((char *)next_tbl, "next_tbl");
+    (void)bu_free((genptr_t)a_tbl, "a_tbl");
+    (void)bu_free((genptr_t)next_tbl, "next_tbl");
 
     return 0;
 }
Index: librt/primitives/nmg/nmg_mk.c
===================================================================
--- librt/primitives/nmg/nmg_mk.c	(revision 54048)
+++ librt/primitives/nmg/nmg_mk.c	(working copy)
@@ -1213,9 +1213,9 @@
 	    struct face_g_snurb *sp;
 	    sp = (struct face_g_snurb *)magic_p;
 	    if (BU_LIST_NON_EMPTY(&(sp->f_hd))) return;
-	    bu_free((char *)sp->u.knots, "nmg_kfg snurb u knots[]");
-	    bu_free((char *)sp->v.knots, "nmg_kfg snurb v knots[]");
-	    bu_free((char *)sp->ctl_points, "nmg_kfg snurb ctl_points[]");
+	    bu_free((genptr_t)sp->u.knots, "nmg_kfg snurb u knots[]");
+	    bu_free((genptr_t)sp->v.knots, "nmg_kfg snurb v knots[]");
+	    bu_free((genptr_t)sp->ctl_points, "nmg_kfg snurb ctl_points[]");
 	    FREE_FACE_G_SNURB(sp);
 	}
 	    break;
@@ -1428,8 +1428,8 @@
 	    eu->g.magic_p = NULL;
 	    if (BU_LIST_NON_EMPTY(&eg->eu_hd2)) return 0;
 	    if (eg->order != 0) {
-		bu_free((char *)eg->k.knots, "nmg_keg cnurb knots[]");
-		bu_free((char *)eg->ctl_points, "nmg_keg cnurb ctl_points[]");
+		bu_free((genptr_t)eg->k.knots, "nmg_keg cnurb knots[]");
+		bu_free((genptr_t)eg->ctl_points, "nmg_keg cnurb ctl_points[]");
 	    }
 	    FREE_EDGE_G_CNURB(eg);
 	    break;
@@ -1690,7 +1690,7 @@
 	(void)nmg_kr(BU_LIST_FIRST(nmgregion, &m->r_hd));
 
     if (m->manifolds) {
-	bu_free((char *)m->manifolds, "free manifolds table");
+	bu_free((genptr_t)m->manifolds, "free manifolds table");
 	m->manifolds = (char *)NULL;
     }
 
Index: librt/primitives/nmg/nmg_index.c
===================================================================
--- librt/primitives/nmg/nmg_index.c	(revision 54048)
+++ librt/primitives/nmg/nmg_index.c	(working copy)
@@ -793,11 +793,11 @@
      * need to be regenerated.
      */
     if (m1->manifolds) {
-	bu_free((char *)m1->manifolds, "free manifolds table");
+	bu_free((genptr_t)m1->manifolds, "free manifolds table");
 	m1->manifolds = (char *)NULL;
     }
     if (m2->manifolds) {
-	bu_free((char *)m2->manifolds, "free manifolds table");
+	bu_free((genptr_t)m2->manifolds, "free manifolds table");
 	m2->manifolds = (char *)NULL;
     }
 
Index: librt/primitives/nmg/nmg_junk.c
===================================================================
--- librt/primitives/nmg/nmg_junk.c	(revision 54048)
+++ librt/primitives/nmg/nmg_junk.c	(working copy)
@@ -160,7 +160,7 @@
 	if (BU_LIST_IS_EMPTY(&v[i]->vu_hd)) continue;
 	FREE_VERTEX(v[i]);
     }
-    bu_free((char *)v, "vertex array");
+    bu_free((genptr_t)v, "vertex array");
     return s;
 }
 
Index: librt/primitives/nmg/nmg_rt_isect.c
===================================================================
--- librt/primitives/nmg/nmg_rt_isect.c	(revision 54048)
+++ librt/primitives/nmg/nmg_rt_isect.c	(working copy)
@@ -160,7 +160,7 @@
     pl_color(fp, 255, 50, 50);
     pdv_3line(fp, pt, plane_pt);
 
-    bu_free((char *)b, "bit vec");
+    bu_free((genptr_t)b, "bit vec");
     fclose(fp);
 }
 
@@ -205,7 +205,7 @@
     nmg_pl_eu(fp, eu, b, 255, 255, 255);
     pl_color(fp, 255, 50, 50);
     pdv_3line(fp, pt, plane_pt);
-    bu_free((char *)b, "bit vec");
+    bu_free((genptr_t)b, "bit vec");
     fclose(fp);
 }
 
@@ -1956,7 +1956,7 @@
 		if (rt_g.NMG_debug & DEBUG_RT_ISECT)
 		    bu_log("\tNot a hit\n");
 
-		bu_free((char *)hp, "hit");
+		bu_free((genptr_t)hp, "hit");
 		hp = next;
 		continue;
 	    }
@@ -2050,7 +2050,7 @@
 
 	    hit_ins(rd, myhit);
 
-	    bu_free((char *)hp, "hit");
+	    bu_free((genptr_t)hp, "hit");
 	    hp = next;
 	}
 	rt_nurb_free_snurb(srf, rd->ap->a_resource);
@@ -2796,7 +2796,7 @@
     }
 
     /* free the hitmiss table */
-    bu_free((char *)rd.hitmiss, "free nmg geom hit list");
+    bu_free((genptr_t)rd.hitmiss, "free nmg geom hit list");
 
     if (!rd.rd_m->manifolds) {
 	/* If there is no manifolds list attached to the model
@@ -2807,7 +2807,7 @@
 	 * function and should be freed in the nmg_bool
 	 * function.
 	 */
-	bu_free((char *)rd.manifolds, "free local manifolds table");
+	bu_free((genptr_t)rd.manifolds, "free local manifolds table");
 	rd.manifolds = NULL; /* sanity */
     }
 
Index: librt/primitives/nmg/nmg_pt_fu.c
===================================================================
--- librt/primitives/nmg/nmg_pt_fu.c	(revision 54048)
+++ librt/primitives/nmg/nmg_pt_fu.c	(working copy)
@@ -757,11 +757,11 @@
 		tmp = ei_p;
 		ei_p = BU_LIST_PLAST(edge_info, &ei_p->l);
 		BU_LIST_DEQUEUE(&tmp->l);
-		bu_free((char *)tmp, "edge info struct");
+		bu_free((genptr_t)tmp, "edge info struct");
 		tmp = ei;
 		ei = BU_LIST_PLAST(edge_info, &ei->l);
 		BU_LIST_DEQUEUE(&tmp->l);
-		bu_free((char *)tmp, "edge info struct");
+		bu_free((genptr_t)tmp, "edge info struct");
 		break;
 	    }
 	    ei_p = BU_LIST_PNEXT(edge_info, &ei_p->l);
@@ -870,7 +870,7 @@
 	pdv_3line(fp, p1, p2);
     }
 
-    bu_free((char *)b, "bit vec");
+    bu_free((genptr_t)b, "bit vec");
     fclose(fp);
 }
 
@@ -972,7 +972,7 @@
      */
     while (BU_LIST_WHILE(ei, edge_info, &near1)) {
 	BU_LIST_DEQUEUE(&ei->l);
-	bu_free((char *)ei, "edge_info struct");
+	bu_free((genptr_t)ei, "edge_info struct");
     }
 
     if (UNLIKELY(rt_g.NMG_debug & DEBUG_PT_FU)) {
@@ -1096,7 +1096,7 @@
 	/* free up the edge_list elements */
 	while (BU_LIST_WHILE(ei, edge_info, &edge_list.l)) {
 	    BU_LIST_DEQUEUE(&ei->l);
-	    bu_free((char *)ei, "edge info struct");
+	    bu_free((genptr_t)ei, "edge info struct");
 	}
     } else if (BU_LIST_FIRST_MAGIC(&lu->down_hd) == NMG_VERTEXUSE_MAGIC) {
 	register struct vertexuse *vu;
@@ -1180,7 +1180,7 @@
 	pdv_3line(fp, p1, p2);
     }
 
-    bu_free((char *)b, "plot table");
+    bu_free((genptr_t)b, "plot table");
     fclose(fp);
 
 }
@@ -1359,7 +1359,7 @@
 
     while (BU_LIST_WHILE(ved_p, ve_dist, &fpi.ve_dh)) {
 	BU_LIST_DEQUEUE(&ved_p->l);
-	bu_free((char *)ved_p, "ve_dist struct");
+	bu_free((genptr_t)ved_p, "ve_dist struct");
     }
 
 
@@ -1474,12 +1474,12 @@
     /* free up the edge_list elements */
     while (BU_LIST_WHILE(ei, edge_info, &edge_list.l)) {
 	BU_LIST_DEQUEUE(&ei->l);
-	bu_free((char *)ei, "edge info struct");
+	bu_free((genptr_t)ei, "edge info struct");
     }
 
     while (BU_LIST_WHILE(ved_p, ve_dist, &fpi.ve_dh)) {
 	BU_LIST_DEQUEUE(&ved_p->l);
-	bu_free((char *)ved_p, "ve_dist struct");
+	bu_free((genptr_t)ved_p, "ve_dist struct");
     }
 
     if (rt_g.NMG_debug & DEBUG_PT_FU)
Index: librt/primitives/nmg/nmg_plot.c
===================================================================
--- librt/primitives/nmg/nmg_plot.c	(revision 54048)
+++ librt/primitives/nmg/nmg_plot.c	(working copy)
@@ -1250,7 +1250,7 @@
 	nmg_vlblock_v(vbp, s->vu_p->v_p, tab);
     }
 
-    bu_free((char *)tab, "nmg_vlblock_s tab[]");
+    bu_free((genptr_t)tab, "nmg_vlblock_s tab[]");
 }
 
 
@@ -1383,7 +1383,7 @@
     rt_plot_vlblock(fp, vbp);
     rt_vlblock_free(vbp);
 
-    bu_free((char *)b, "nmg_pl_isect flags[]");
+    bu_free((genptr_t)b, "nmg_pl_isect flags[]");
 
     (void)fclose(fp);
 }
@@ -1445,7 +1445,7 @@
 	}
     }
     rt_vlblock_free(vbp);
-    bu_free((char *)tab, "nmg_pl_comb_fu tab[]");
+    bu_free((genptr_t)tab, "nmg_pl_comb_fu tab[]");
 }
 
 
@@ -1508,7 +1508,7 @@
     }
 
     rt_vlblock_free(vbp);
-    bu_free((char *)tab, "nmg_pl_2fu tab[]");
+    bu_free((genptr_t)tab, "nmg_pl_2fu tab[]");
 }
 
 
@@ -1927,7 +1927,7 @@
 
 	rt_vlblock_free(vbp);
 	vbp = (struct bn_vlblock *)NULL;
-	bu_free((char *)broken_tab, "broken_tab");
+	bu_free((genptr_t)broken_tab, "broken_tab");
 	broken_tab = (long *)NULL;
 	broken_tab_len = 0;
     }
@@ -1988,7 +1988,7 @@
 	}
     }
     rt_vlblock_free(vbp);
-    bu_free((char *)tab, "nmg_face_plot tab[]");
+    bu_free((genptr_t)tab, "nmg_face_plot tab[]");
 
 }
 
@@ -2034,7 +2034,7 @@
 	bu_log("null nmg_vlblock_anim_upcall, no animation\n");
     }
     rt_vlblock_free(vbp);
-    bu_free((char *)tab, "nmg_2face_plot tab[]");
+    bu_free((genptr_t)tab, "nmg_2face_plot tab[]");
 
 }
 
@@ -2086,7 +2086,7 @@
 
     fclose(fp);
     bu_log("overlay %s\n", buf);
-    bu_free((char *)b, "nmg_face_lu_plot flag[]");
+    bu_free((genptr_t)b, "nmg_face_lu_plot flag[]");
 }
 
 
@@ -2143,7 +2143,7 @@
 
     fclose(fp);
     bu_log("overlay %s\n", buf);
-    bu_free((char *)b, "nmg_plot_lu_ray flag[]");
+    bu_free((genptr_t)b, "nmg_plot_lu_ray flag[]");
 }
 
 
@@ -2174,7 +2174,7 @@
 
     nmg_pl_fu(fp, fu, b, 200, 200, 200);
 
-    bu_free((char *)b, "bit vec");
+    bu_free((genptr_t)b, "bit vec");
 
     VSCALE(pp, dir, 1000.0);
     VADD2(pp, pt, pp);
@@ -2236,7 +2236,7 @@
     rt_plot_vlblock(fp, vbp);
     (void)fclose(fp);
     rt_vlblock_free(vbp);
-    bu_free((char *)tab, "bit vec");
+    bu_free((genptr_t)tab, "bit vec");
 }
 
 
@@ -2322,10 +2322,10 @@
     rt_nurb_free_snurb(c, (struct resource *)NULL);
     rt_nurb_free_snurb(r, (struct resource *)NULL);
 
-    bu_free((char *) tau1.knots, "rt_nurb_plot:tau1.knots");
-    bu_free((char *) tau2.knots, "rt_nurb_plot:tau2.knots");
-    bu_free((char *) tkv1.knots, "rt_nurb_plot:tkv1>knots");
-    bu_free((char *) tkv2.knots, "rt_nurb_plot:tkv2.knots");
+    bu_free((genptr_t) tau1.knots, "rt_nurb_plot:tau1.knots");
+    bu_free((genptr_t) tau2.knots, "rt_nurb_plot:tau2.knots");
+    bu_free((genptr_t) tkv1.knots, "rt_nurb_plot:tkv1>knots");
+    bu_free((genptr_t) tkv2.knots, "rt_nurb_plot:tkv2.knots");
 
     return 0;
 }
@@ -2459,8 +2459,8 @@
     }
 
     if (eg->order <= 0) {
-	bu_free((char *)n.k.knots, "nmg_cnurb_to_vlist() n.knot.knots");
-	bu_free((char *)n.ctl_points, "nmg_cnurb_to_vlist() ctl_points");
+	bu_free((genptr_t)n.k.knots, "nmg_cnurb_to_vlist() n.knot.knots");
+	bu_free((genptr_t)n.ctl_points, "nmg_cnurb_to_vlist() ctl_points");
     }
 }
 
Index: librt/primitives/nmg/nmg_mod.c
===================================================================
--- librt/primitives/nmg/nmg_mod.c	(revision 54048)
+++ librt/primitives/nmg/nmg_mod.c	(working copy)
@@ -193,7 +193,7 @@
 	}
     }
 
-    bu_free((char *)flags, "nmg_shell_coplanar_face_merge flags[]");
+    bu_free((genptr_t)flags, "nmg_shell_coplanar_face_merge flags[]");
 
     nmg_shell_a(s, tol);
 
@@ -1947,7 +1947,7 @@
     new_fu->orientation = fu->orientation;
     new_fu->fumate_p->orientation = fu->fumate_p->orientation;
 
-    bu_free((char *)trans_tbl, "nmg_dup_face trans_tbl");
+    bu_free((genptr_t)trans_tbl, "nmg_dup_face trans_tbl");
 
     if (rt_g.NMG_debug & DEBUG_BASIC) {
 	bu_log("nmg_dup_face(fu=x%x, s=x%x) new_fu=x%x\n",
@@ -2383,7 +2383,7 @@
 	    nmg_pl_fu(fd, oldlu->up.fu_p, tab, 100, 100, 100);
 	    nmg_pl_fu(fd, oldlu->up.fu_p->fumate_p, tab, 100, 100, 100);
 	    (void)fclose(fd);
-	    bu_free((char *)tab, "nmg_cut_loop flag[] 1");
+	    bu_free((genptr_t)tab, "nmg_cut_loop flag[] 1");
 	}
     }
 
@@ -2455,7 +2455,7 @@
 	nmg_pl_fu(fd, oldlu->up.fu_p, tab, 100, 100, 100);
 	nmg_pl_fu(fd, oldlu->up.fu_p->fumate_p, tab, 100, 100, 100);
 	(void)fclose(fd);
-	bu_free((char *)tab, "nmg_cut_loop flag[] 2");
+	bu_free((genptr_t)tab, "nmg_cut_loop flag[] 2");
     }
  out:
     if (rt_g.NMG_debug & DEBUG_BASIC) {
@@ -3142,9 +3142,9 @@
 
     if (jaunt_count == 0) {
 	if (visit_count)
-	    bu_free((char *)visit_count, "nmg_loop_split_at_touching_jaunt: visit_count[]\n");
+	    bu_free((genptr_t)visit_count, "nmg_loop_split_at_touching_jaunt: visit_count[]\n");
 	if (jaunt_status)
-	    bu_free((char *)jaunt_status, "nmg_loop_split_at_touching_jaunt: jaunt_status[]\n");
+	    bu_free((genptr_t)jaunt_status, "nmg_loop_split_at_touching_jaunt: jaunt_status[]\n");
 	if (!need_init)
 	    bu_ptbl_free(&jaunt_tbl);
 
@@ -3171,9 +3171,9 @@
 
 	bu_ptbl_free(&jaunt_tbl);
 	if (visit_count)
-	    bu_free((char *)visit_count, "nmg_loop_split_at_touching_jaunt: visit_count[]\n");
+	    bu_free((genptr_t)visit_count, "nmg_loop_split_at_touching_jaunt: visit_count[]\n");
 	if (jaunt_status)
-	    bu_free((char *)jaunt_status, "nmg_loop_split_at_touching_jaunt: jaunt_status[]\n");
+	    bu_free((genptr_t)jaunt_status, "nmg_loop_split_at_touching_jaunt: jaunt_status[]\n");
 
 	if ((rt_g.NMG_debug & DEBUG_BASIC) || (rt_g.NMG_debug & DEBUG_CUTLOOP)) {
 	    bu_log("nmg_loop_split_at_touching_jaunt(lu=x%x) END count=%d\n",
@@ -3203,9 +3203,9 @@
     BU_CK_PTBL(&jaunt_tbl);
 
     if (visit_count)
-	bu_free((char *)visit_count, "nmg_loop_split_at_touching_jaunt: visit_count[]\n");
+	bu_free((genptr_t)visit_count, "nmg_loop_split_at_touching_jaunt: visit_count[]\n");
     if (jaunt_status)
-	bu_free((char *)jaunt_status, "nmg_loop_split_at_touching_jaunt: jaunt_status[]\n");
+	bu_free((genptr_t)jaunt_status, "nmg_loop_split_at_touching_jaunt: jaunt_status[]\n");
 
     visit_count = (int *)bu_calloc(BU_PTBL_END(&jaunt_tbl), sizeof(int),
 				   "nmg_loop_split_at_touching_jaunt: visit_count[]");
Index: librt/primitives/nmg/nmg_extrude.c
===================================================================
--- librt/primitives/nmg/nmg_extrude.c	(revision 54048)
+++ librt/primitives/nmg/nmg_extrude.c	(working copy)
@@ -174,7 +174,7 @@
 	bu_bomb("nmg_translate_face: Cannot calculate plane equation for face\n");
     }
     nmg_face_g(fu_tmp, pl);
-    bu_free((char *)verts, "verts");
+    bu_free((genptr_t)verts, "verts");
 }
 
 
@@ -262,7 +262,7 @@
 
     nmg_gluefaces(outfaces, face_count, tol);
 
-    bu_free((char *)outfaces, "nmg_extrude_face: outfaces");
+    bu_free((genptr_t)outfaces, "nmg_extrude_face: outfaces");
 
     return 0;
 }
@@ -681,7 +681,7 @@
 		}
 
 		bu_ptbl_free(loop_tab);
-		bu_free((char *)loop_tab, "nmg_fix_overlapping_loops: loop_tab");
+		bu_free((genptr_t)loop_tab, "nmg_fix_overlapping_loops: loop_tab");
 	    }
 	}
 
@@ -1164,8 +1164,8 @@
 	nmg_region_a(s_tmp->r_p, tol);
 
 	/* free memory */
-	bu_free((char *)flags, "nmg_extrude_shell: flags");
-	bu_free((char *)copy_tbl, "nmg_extrude_shell: copy_tbl");
+	bu_free((genptr_t)flags, "nmg_extrude_shell: flags");
+	bu_free((genptr_t)copy_tbl, "nmg_extrude_shell: copy_tbl");
     }
 
     /* put it all back together */
@@ -1286,7 +1286,7 @@
 	    }
 	}
 
-	bu_free((char *)flags, "nmg_extrude_shell flags");
+	bu_free((genptr_t)flags, "nmg_extrude_shell flags");
 
 	/* get table of vertices in this shell */
 	nmg_vertex_tabulate(&verts, &s_tmp->l.magic);
Index: librt/primitives/nmg/nmg.c
===================================================================
--- librt/primitives/nmg/nmg.c	(revision 54048)
+++ librt/primitives/nmg/nmg.c	(working copy)
@@ -223,7 +223,7 @@
     status = nmg_ray_segs(&rd);
 
     /* free the hitmiss table */
-    bu_free((char *)rd.hitmiss, "free nmg geom hit list");
+    bu_free((genptr_t)rd.hitmiss, "free nmg geom hit list");
 
     return status;
 }
@@ -298,7 +298,7 @@
 	(struct nmg_specific *)stp->st_specific;
 
     nmg_km(nmg->nmg_model);
-    bu_free((char *)nmg, "nmg_specific");
+    bu_free((genptr_t)nmg, "nmg_specific");
     stp->st_specific = NULL; /* sanity */
 }
 
@@ -2199,8 +2199,8 @@
     ip->idb_meth = &rt_functab[ID_NMG];
     ip->idb_ptr = (genptr_t)m;
 
-    bu_free((char *)ecnt, "ecnt[]");
-    bu_free((char *)real_ptrs, "ptrs[]");
+    bu_free((genptr_t)ecnt, "ecnt[]");
+    bu_free((genptr_t)real_ptrs, "ptrs[]");
 
     return 0;			/* OK */
 }
@@ -2558,8 +2558,8 @@
     ip->idb_meth = &rt_functab[ ID_NMG ];
     ip->idb_ptr = (genptr_t)m;
     NMG_CK_MODEL(m);
-    bu_free((char *)ecnt, "ecnt[]");
-    bu_free((char *)real_ptrs, "ptrs[]");
+    bu_free((genptr_t)ecnt, "ecnt[]");
+    bu_free((genptr_t)real_ptrs, "ptrs[]");
 
     if (RT_G_DEBUG || rt_g.NMG_debug) {
 	nmg_vmodel(m);
@@ -2762,8 +2762,8 @@
 		     (genptr_t)(ptrs[i]), ecnt, i, local2mm);
     }
 
-    bu_free((char *)ptrs, "ptrs[]");
-    bu_free((char *)ecnt, "ecnt[]");
+    bu_free((genptr_t)ptrs, "ptrs[]");
+    bu_free((genptr_t)ecnt, "ecnt[]");
     return 0;		/* OK */
 }
 
@@ -3033,7 +3033,7 @@
 			face_verts[j] = &verts[loop[j]].v;
 		    }
 		    fu = nmg_cmface(s, face_verts, loop_len);
-		    bu_free((char *)face_verts, "face_verts");
+		    bu_free((genptr_t)face_verts, "face_verts");
 		}
 	    }
 	} else {
